#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
#######################################################################
#
#    MyMetrix
#    Coded by iMaxxx (c) 2013
#    Support: www..dreambox-tools.info
#    Mod MyMetrixStyle for Merlin³ by arki
#
#  This plugin is licensed under the Creative Commons
#  Attribution-NonCommercial-ShareAlike 3.0 Unported License.
#  To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/3.0/
#  or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
#
#  Alternatively, this plugin may be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.
#
#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially
#  distributed other than under the conditions noted above.
#
#######################################################################

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.ChoiceBox import ChoiceBox
from twisted.web.client import downloadPage
from Screens.Console import Console
from Screens.Standby import TryQuitMainloop
from Components.ActionMap import ActionMap
from Components.AVSwitch import AVSwitch
from Components.config import config, configfile, ConfigYesNo, ConfigSubsection, getConfigListEntry, ConfigSelection, ConfigNumber, ConfigText, ConfigInteger
from Components.ConfigList import ConfigListScreen
from Components.Label import Label
from Components.Language import language
from os import environ, listdir, remove, rename, system
from skin import parseColor
from Components.Pixmap import Pixmap
from Components.Label import Label
import urllib
import gettext
from enigma import ePicLoad
from Tools.Directories import fileExists, resolveFilename, SCOPE_LANGUAGE, SCOPE_PLUGINS

#############################################################

lang = language.getLanguage()
environ["LANGUAGE"] = lang[:2]
gettext.bindtextdomain("enigma2", resolveFilename(SCOPE_LANGUAGE))
gettext.textdomain("enigma2")
gettext.bindtextdomain("MyMetrixStyle", "%s%s" % (resolveFilename(SCOPE_PLUGINS), "Extensions/MyMetrixStyle/locale/"))

def _(txt):
	t = gettext.dgettext("MyMetrixStyle", txt)
	if t == txt:
		t = gettext.gettext(txt)
	return t

def translateBlock(block):
	for x in TranslationHelper:
		if block.__contains__(x[0]):
			block = block.replace(x[0], x[1])
	return block

#############################################################

config.plugins.MyMetrixStyle = ConfigSubsection()

#General
config.plugins.MyMetrixStyle.SkinSelectedBackgroundColor = ConfigSelection(default="#00149bae", choices = [
				("#00F0A30A", _("amber")),
				("#00825A2C", _("brown")),
				("#000050EF", _("cobalt")),
				("#001677d2", _("blueberry")),				
				("#00911d10", _("crimson")),
				("#001BA1E2", _("cyan")),
				("#00a61d4d", _("magenta")),
				("#00A4C400", _("lime green")),
				("#006A00FF", _("indigo")),
				("#0070ad11", _("green")),
				("#00008A00", _("emerald")),
				("#0076608A", _("mauve")),
				("#006D8764", _("oliv")),
				("#00c3461b", _("orange")),
				("#00F472D0", _("pink")),
				("#00E51400", _("blood red")),
				("#007A3B3F", _("siena")),
				("#00647687", _("steel")),
				("#00149bae", _("Classic")),
				("#006c0aab", _("violett")),
				("#00bf9217", _("gold")),
				("#00ffcc00", _("yellow")),
				("#00cea66b", _("beige")),				
				("#40000001", _("Metrix")),
				("#30111010", _("anthrazit")),				
				("#00000000", _("black")),												
				("#05000080", _("blue")),
				("#15003c51", _("turquoise")),				
				("#05770000", _("red")),
				("#05002900", _("pine green"))				
				])
config.plugins.MyMetrixStyle.SkinSelectedLine = ConfigSelection(default="line-no", choices = [
				("p_bar", _("grey")),
				("p_bar_cyan", _("cyan")),
				("p_bar_yellow", _("yellow")),				
				("line-no", _("No"))
				])				
config.plugins.MyMetrixStyle.SkinSelectedForegroundColor = ConfigSelection(default="#00fffffd", choices = [
				("#00fffffd", _("Classic")),
				("#00F0A30A", _("amber")),
				("#00825A2C", _("brown")),
				("#000050EF", _("cobalt")),
				("#001677d2", _("blueberry")),				
				("#00911d10", _("crimson")),
				("#001BA1E2", _("cyan")),
				("#00a61d4d", _("magenta")),
				("#00A4C400", _("lime green")),
				("#006A00FF", _("indigo")),
				("#0070ad11", _("green")),
				("#00008A00", _("emerald")),
				("#0076608A", _("mauve")),
				("#006D8764", _("oliv")),
				("#00c3461b", _("orange")),
				("#00F472D0", _("pink")),
				("#00E51400", _("blood red")),
				("#007A3B3F", _("siena")),
				("#00647687", _("steel")),
				("#00149baf", _("teal")),
				("#006c0aab", _("violett")),
				("#00bf9217", _("gold")),
				("#00ffcc00", _("yellow")),
				("#00cea66b", _("beige")),				
				("#00000000", _("black"))
				])								
config.plugins.MyMetrixStyle.SkinBackgroundColor = ConfigSelection(default="#40000000", choices = [
				("#40000000", _("Metrix")),
				("#30111010", _("anthrazit")),			
				("#00000000", _("black")),												
				("#05000080", _("blue")),
				("#15003c51", _("turquoise")),				
				("#05770000", _("red")),
				("#05002900", _("pine green"))
				])
config.plugins.MyMetrixStyle.SkinForegroundColor = ConfigSelection(default="#00dddddd", choices = [
				("#00dddddd", _("Classic")),				
				("#00bf9217", _("gold")),				
				("#00cea66b", _("beige")),
				("#00008A00", _("emerald")),
				("#000050EF", _("cobalt")),
				("#00E51400", _("blood red"))				
				])				
config.plugins.MyMetrixStyle.SkinClockColor = ConfigSelection(default="#00fffffe", choices = [
				("#00fffffe", _("Classic")),
				("#00F0A30A", _("amber")),
				("#00825A2C", _("brown")),
				("#000050EF", _("cobalt")),
				("#001677d2", _("blueberry")),				
				("#00911d10", _("crimson")),
				("#001BA1E2", _("cyan")),
				("#00a61d4d", _("magenta")),
				("#00A4C400", _("lime green")),
				("#006A00FF", _("indigo")),
				("#0070ad11", _("green")),
				("#00008A00", _("emerald")),
				("#0076608A", _("mauve")),
				("#006D8764", _("oliv")),
				("#00c3461b", _("orange")),
				("#00F472D0", _("pink")),
				("#00E51400", _("blood red")),
				("#007A3B3F", _("siena")),
				("#00647687", _("steel")),
				("#00149baf", _("teal")),
				("#006c0aab", _("violett")),
				("#00bf9217", _("gold")),
				("#00ffcc00", _("yellow")),
				("#00cea66b", _("beige"))
				])
config.plugins.MyMetrixStyle.SkinSelectedHelpTextColor = ConfigSelection(default="#00fffffc", choices = [
				("#00fffffc", _("Classic")),
				("#00F0A30A", _("amber")),
				("#00825A2C", _("brown")),
				("#000050EF", _("cobalt")),
				("#001677d2", _("blueberry")),				
				("#00911d10", _("crimson")),
				("#001BA1E2", _("cyan")),
				("#00a61d4d", _("magenta")),
				("#00A4C400", _("lime green")),
				("#006A00FF", _("indigo")),
				("#0070ad11", _("green")),
				("#00008A00", _("emerald")),
				("#0076608A", _("mauve")),
				("#006D8764", _("oliv")),
				("#00c3461b", _("orange")),
				("#00F472D0", _("pink")),
				("#00E51400", _("blood red")),
				("#007A3B3F", _("siena")),
				("#00647687", _("steel")),
				("#00149baf", _("teal")),
				("#006c0aab", _("violett")),
				("#00bf9217", _("gold")),
				("#00ffcc00", _("yellow")),
				("#00cea66b", _("beige"))				
				])
config.plugins.MyMetrixStyle.SkinCaidInfoColor = ConfigSelection(default="#00008A01", choices = [
				("#00F0A30A", _("amber")),
				("#00825A2C", _("brown")),
				("#000050EF", _("cobalt")),
				("#001677d2", _("blueberry")),				
				("#00911d10", _("crimson")),
				("#001BA1E2", _("cyan")),
				("#00a61d4d", _("magenta")),
				("#00A4C400", _("lime green")),
				("#006A00FF", _("indigo")),
				("#0070ad11", _("green")),
				("#00008A01", _("Classic")),
				("#0076608A", _("mauve")),
				("#006D8764", _("oliv")),
				("#00c3461b", _("orange")),
				("#00F472D0", _("pink")),
				("#00E51400", _("blood red")),
				("#007A3B3F", _("siena")),
				("#00647687", _("steel")),
				("#00149baf", _("teal")),
				("#006c0aab", _("violett")),
				("#00bf9217", _("gold")),
				("#00ffcc00", _("yellow")),
				("#00cea66b", _("beige"))				
				])				
config.plugins.MyMetrixStyle.SkinTunerInfoColor = ConfigSelection(default="#0070ad11", choices = [
				("#00ddddde", _("Classic")),
				("#00F0A30A", _("amber")),
				("#00825A2C", _("brown")),
				("#000050EF", _("cobalt")),
				("#001677d2", _("blueberry")),				
				("#00911d10", _("crimson")),
				("#001BA1E2", _("cyan")),
				("#00a61d4d", _("magenta")),
				("#00A4C400", _("lime green")),
				("#006A00FF", _("indigo")),
				("#0070ad11", _("green")),
				("#00008A00", _("emerald")),
				("#0076608A", _("mauve")),
				("#006D8764", _("oliv")),
				("#00c3461b", _("orange")),
				("#00F472D0", _("pink")),
				("#00E51400", _("blood red")),
				("#007A3B3F", _("siena")),
				("#00647687", _("steel")),
				("#00149baf", _("teal")),
				("#006c0aab", _("violett")),
				("#00bf9217", _("gold")),
				("#00ffcc00", _("yellow")),
				("#00cea66b", _("beige"))
				])				
config.plugins.MyMetrixStyle.SkinProgressbarColor = ConfigSelection(default="p_bar", choices = [
				("p_bar", _("Classic")),
				("p_bar_amber", _("amber")),
				("p_bar_brown", _("brown")),
				("p_bar_cobalt", _("cobalt")),
				("p_bar_blue", _("blueberry")),
				("p_bar_crimson", _("crimson")),
				("p_bar_cyan", _("cyan")),
				("p_bar_magenta", _("magenta")),
				("p_bar_lime", _("lime green")),
				("p_bar_indigo", _("indigo")),
				("p_bar_green", _("green")),
				("p_bar_emerald", _("emerald")),
				("p_bar_mauve", _("mauve")),
				("p_bar_olive", _("oliv")),
				("p_bar_orange", _("orange")),
				("p_bar_pink", _("pink")),
				("p_bar_red", _("blood red")),
				("p_bar_sienna", _("siena")),
				("p_bar_steel", _("steel")),
				("p_bar_teal", _("teal")),
				("p_bar_violet", _("violett")),
				("p_bar_gold", _("gold")),
				("p_bar_yellow", _("yellow")),
				("p_bar_beige",_("beige"))
				])								
config.plugins.MyMetrixStyle.Channeldescription = ConfigSelection(default="#00999998", choices = [
				("#00A4C400", _("lime green")),
				("#0070ad11", _("green")),
				("#001BA1E2", _("cyan")),
				("#00149baf", _("teal")),
				("#00999998", _("Classic")),
				("#00cea66b", _("beige")),
				("#00ffcc00", _("yellow"))
				])				

#Plugin-Styles
config.plugins.MyMetrixStyle.MovieSelectionStyle = ConfigSelection(default="movieselection-classic", choices = [
				("movieselection-classic", _("Classic")),				
				("movieselection-simple", _("Cover"))
				])
config.plugins.MyMetrixStyle.MenuStyle = ConfigSelection(default="menu-center", choices = [
				("menu-center", _("Classic")),
				("menu-left", _("Left")),
				("menu-big", _("big"))				
				])
config.plugins.MyMetrixStyle.VolumeStyle = ConfigSelection(default="volume-classic", choices = [
				("volume-classic", _("Classic")),				
				("volume-new", _("big"))
				])
config.plugins.MyMetrixStyle.AMSStyle = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("ams-metrix", _("On"))
				])				
config.plugins.MyMetrixStyle.EMCStyle = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("emc-metrix", _("Metrix")),
				("emc-metrix-pic", _("Metrix PIG"))				
				])
config.plugins.MyMetrixStyle.MerlinEPGCenterStyle = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("merlinepgcenter", _("On"))				
				])	
				
#Channelselection
config.plugins.MyMetrixStyle.ChannelselectionStyle = ConfigSelection(default="channelselection-classic", choices = [
				("channelselection-classic", _("Classic")),
				("channelselection-me12", _("Merlin 12z")),				
				("channelselection-me16", _("Merlin 16z")),
				("channelselection-me1ev", _("Merlin-1Event")),				
				("channelselection-me3ev", _("Merlin-3Event")),
				("channelselection-pic-left", _("MiniTV left")),				
				("channelselection-pic-right", _("MiniTV right")),
				("channelselection-2pic", _("Mini 2TV")),				
				("channelselection-simple", _("Simple"))				
				])				
				
#InfoBar
config.plugins.MyMetrixStyle.InfobarStyle = ConfigSelection(default="infobar-style-classic", choices = [
				("infobar-style-classic", _("Classic")),
				("infobar-style-metrix", _("Metrix")),				
				("infobar-style-metrix1", _("Metrix (Ticker) ")),				
				("infobar-style-merlin1", _("HC")),				
				("infobar-style-merlin2", _("HC (Ticker) ")),			
				("infobar-style-merlin3", _("Merlin")),
				("infobar-style-merlin4", _("Merlin (Ticker)"))				
				])
config.plugins.MyMetrixStyle.InfobarShowChannelname = ConfigSelection(default="infobar-channelname-number", choices = [
				("no-widget", _("Off")),				
				("infobar-channelname-number", _("Classic")),
				("infobar-channelname-number-left", _("Left"))				
				])				
config.plugins.MyMetrixStyle.InfobarTopLeft = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("infobar-top-left-clockdate", _("Clock/Date")),
				("infobar-top-left-clockdatecolored", _("Clock/Date (Date color)")),
				("infobar-top-left-clockdateextended", _("Clock/Date extended")),				
				("infobar-top-left-msnweather", _("MSN-Weather"))				
				])
config.plugins.MyMetrixStyle.InfobarTopCenter = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("infobar-top-center-syteminfo", _("Show System Info")),
				("infobar-top-center-cryptinfo", _("Show Softcam Info")),				
				("infobar-top-center-serviceinfo", _("Serviceinfo"))
				])				
config.plugins.MyMetrixStyle.InfobarTopRight = ConfigSelection(default="infobar-top-right-clockdate", choices = [
				("no-widget", _("Off")),
				("infobar-top-right-clockdate", _("Clock/Date")),
				("infobar-top-right-clockdatecolored", _("Clock/Date (Date color)")),				
				("infobar-top-right-clockdateextended", _("Clock/Date extended")),				
				("infobar-top-right-msnweather", _("MSN-Weather"))				
				])				
config.plugins.MyMetrixStyle.InfobarHead = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("infobar-head-cryptinfo", _("Show Softcam Info")),
				("infobar-head-icons", _("Icons new")),
				("infobar-head-serviceinfo", _("Serviceinfo")),
				("infobar-head-colorbuttonts", _("Show Colorbuttonts"))				
				])								
config.plugins.MyMetrixStyle.InfobarBottomLeft = ConfigSelection(default="infobar-bottom-left-resolutionhealth", choices = [
				("no-widget", _("Off")),
				("infobar-bottom-left-caidhealth", _("Show CAID/Health db")),
				("infobar-bottom-left-caidsoftcam", _("Show CAID/SoftCam")),				
				("infobar-bottom-left-resolutionhealthpg", _("Show Resulotion/Health progress")),
				("infobar-bottom-left-resolution-temp-health", _("Show Resulotion/Temp/Health")),				
				("infobar-bottom-left-resolutionhealth", _("Show Resulotion/Health")),
				("infobar-bottom-left-resolution-provider", _("Show Resulotion/Provider"))				
				])
config.plugins.MyMetrixStyle.InfobarBottomCenter = ConfigSelection(default="infobar-tunerinfo-ab", choices = [
				("infobar-tunerinfo-ab", _("2 Tuner (AB S/C/T)")),
				("infobar-tunerinfo-abc", _("3 Tuner (ABC S/C/T)")),				
				("infobar-tunerinfo-abcd", _("4 Tuner (ABCD S/C/T)")),
				("infobar-bottom-center-temp", _("Temp.")),
				("infobar-bottom-center-snr", _("Signal %")),
				("infobar-bottom-center-resolution", _("Resolution")),				
				("no-widget", _("Off"))
				])				
config.plugins.MyMetrixStyle.InfobarBottomRight = ConfigSelection(default="infobar-bottom-right-icons", choices = [
				("infobar-bottom-right-icons", _("Icons classic")),
				("infobar-bottom-right-icons_new", _("Icons new")),				
				("infobar-bottom-right-health-temp", _("Show Signal/Temp")),
				("infobar-bottom-right-tp", _("Tp.Info")),				
				("no-widget", _("Off"))				
				])
config.plugins.MyMetrixStyle.InfobarRecordState = ConfigSelection(default="infobar-recordstate-png", choices = [
				("infobar-recordstate-png", _("Classic")),
				("infobar-recordstate-red", _("Red")),
				("no-widget", _("Off"))				
				])				
				
#SecondInfoBar
config.plugins.MyMetrixStyle.SecondInfobarTopLeft = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("infobar-top-left-clockdate", _("Clock/Date")),
				("infobar-top-left-clockdatecolored", _("Clock/Date (Date color)")),
				("infobar-top-left-clockdateextended", _("Clock/Date extended")),				
				("infobar-top-left-msnweather", _("MSN-Weather"))				
				])
config.plugins.MyMetrixStyle.SecondInfobarTopCenter = ConfigSelection(default="no-widget", choices = [
				("no-widget", _("Off")),
				("infobar-top-center-syteminfo", _("Show System Info")),
				("infobar-top-center-cryptinfo", _("Show Softcam Info")),					
				("infobar-top-center-serviceinfo", _("Serviceinfo"))
				])				
config.plugins.MyMetrixStyle.SecondInfobarTopRight = ConfigSelection(default="infobar-top-right-clockdate", choices = [
				("no-widget", _("Off")),
				("infobar-top-right-clockdate", _("Clock/Date")),
				("infobar-top-right-clockdatecolored", _("Clock/Date (Date color)")),				
				("infobar-top-right-clockdateextended", _("Clock/Date extended")),				
				("infobar-top-right-msnweather", _("MSN-Weather"))				
				])				
config.plugins.MyMetrixStyle.SecondInfobarEPGWidget = ConfigSelection(default="secondinfobar-epgwidget", choices = [
				("secondinfobar-epgwidget", _("Now/Next description")),				
				("no-widget", _("Off"))
				])								

def main(session, **kwargs):
	session.open(MyMetrixStyle,"/usr/lib/enigma2/python/Plugins/Extensions/MyMetrixStyle/images/metrixcolors.png")

def Plugins(**kwargs):
	return PluginDescriptor(name="MyMetrixStyle", description=_("Configuration tool for MetrixStyleHD.ME"), where = PluginDescriptor.WHERE_PLUGINMENU, icon="plugin.png", fnc=main)



#######################################################################


class MyMetrixStyle(ConfigListScreen, Screen):
	skin = """
<screen name="MyMetrixStyle-Setup" position="40,40" size="1200,640" flags="wfNoBorder" backgroundColor="#40000000">
	<eLabel position="20,15" size="300,50" text="MyMetrixStyle" font="Regular; 40" valign="center" transparent="1" backgroundColor="#40000000" />
	<eLabel position="325,18" size="350,50" text="Setup" foregroundColor="#00ffffff" font="Regular; 30" valign="center" backgroundColor="#40000000" transparent="1" halign="left" />
	<widget name="config" position="20,100" scrollbarMode="showOnDemand" size="590,450" transparent="1" />	
	<eLabel font="Regular; 20" foregroundColor="#00ffffff" backgroundColor="#40000000" valign="center" position="35,600" size="250,30" text="Cancel" transparent="1" />
	<eLabel font="Regular; 20" foregroundColor="#00ffffff" backgroundColor="#40000000" valign="center" position="335,600" size="250,30" text="Save" transparent="1" />
	<eLabel font="Regular; 20" foregroundColor="#00ffffff" backgroundColor="#40000000" valign="center" position="640,600" size="250,30" text="Reboot" transparent="1" /> 
	<eLabel position="20,600" size="6,30" backgroundColor="#00ff0000" />
	<eLabel position="320,600" size="6,30" backgroundColor="#0000ff00" />	
	<eLabel position="625,600" size="6,30" backgroundColor="#00ffff00" />
	<widget name="helperimage" position="630,80" size="550,500" zPosition="1" />
</screen>
"""

	def __init__(self, session, args = None, picPath = None):
		self.version = "v1.1b"
		self.skin_lines = []
		Screen.__init__(self, session)
		self.session = session
		self.datei = "/usr/share/enigma2/MetrixStyleHD.ME/skin.xml"
		self.dateiTMP = "/usr/share/enigma2/MetrixStyleHD.ME/skin.xml.tmp"
		self.daten = "/usr/lib/enigma2/python/Plugins/Extensions/MyMetrixStyle/data/"
		self.komponente = "/usr/lib/enigma2/python/Plugins/Extensions/MyMetrixStyle/comp/"
		self.picPath = picPath
		self.Scale = AVSwitch().getFramebufferScale()
		self.PicLoad = ePicLoad()
		self["helperimage"] = Pixmap()
		list = []		
		list.append(getConfigListEntry(_("Selection backgroundcolor"), config.plugins.MyMetrixStyle.SkinSelectedBackgroundColor))
		list.append(getConfigListEntry(_("... with line"), config.plugins.MyMetrixStyle.SkinSelectedLine))		
		list.append(getConfigListEntry(_("Selection textcolor"), config.plugins.MyMetrixStyle.SkinSelectedForegroundColor))		
		list.append(getConfigListEntry(_("Backgroundcolor"), config.plugins.MyMetrixStyle.SkinBackgroundColor))
		list.append(getConfigListEntry(_("Fond color"), config.plugins.MyMetrixStyle.SkinForegroundColor))
		list.append(getConfigListEntry(_("Helptext color"), config.plugins.MyMetrixStyle.SkinSelectedHelpTextColor))		
		list.append(getConfigListEntry(_("Date color"), config.plugins.MyMetrixStyle.SkinClockColor))
		list.append(getConfigListEntry(_("CAID color"), config.plugins.MyMetrixStyle.SkinCaidInfoColor))		
		list.append(getConfigListEntry(_("Health color"), config.plugins.MyMetrixStyle.SkinTunerInfoColor))	
		list.append(getConfigListEntry(_("Progressbar color"), config.plugins.MyMetrixStyle.SkinProgressbarColor))		
		list.append(getConfigListEntry(_("Mainmenu"), config.plugins.MyMetrixStyle.MenuStyle))
		list.append(getConfigListEntry(_("Volume"), config.plugins.MyMetrixStyle.VolumeStyle))
		list.append(getConfigListEntry(_("Select a movie"), config.plugins.MyMetrixStyle.MovieSelectionStyle))
		list.append(getConfigListEntry(_("--------------------------- Plugins --------------------------------"), ))		
		list.append(getConfigListEntry(_("AMS"), config.plugins.MyMetrixStyle.AMSStyle))
		list.append(getConfigListEntry(_("EMC"), config.plugins.MyMetrixStyle.EMCStyle))
		list.append(getConfigListEntry(_("Merlin EPG Center"), config.plugins.MyMetrixStyle.MerlinEPGCenterStyle))		
		list.append(getConfigListEntry(_("------------------------ Channel Selection ----------------------------------------------"), ))
		list.append(getConfigListEntry(_("Channellist Style"), config.plugins.MyMetrixStyle.ChannelselectionStyle))
		list.append(getConfigListEntry(_("Description color"), config.plugins.MyMetrixStyle.Channeldescription))		
		list.append(getConfigListEntry(_("---------------------------- InfoBar ---------------------------------------------"), ))
		list.append(getConfigListEntry(_("Style"), config.plugins.MyMetrixStyle.InfobarStyle))
		list.append(getConfigListEntry(_("Servicename and number"), config.plugins.MyMetrixStyle.InfobarShowChannelname))		
		list.append(getConfigListEntry(_("top left"), config.plugins.MyMetrixStyle.InfobarTopLeft))
		list.append(getConfigListEntry(_("top center"), config.plugins.MyMetrixStyle.InfobarTopCenter))		
		list.append(getConfigListEntry(_("top right"), config.plugins.MyMetrixStyle.InfobarTopRight))		
		list.append(getConfigListEntry(_("over the Infobar"), config.plugins.MyMetrixStyle.InfobarHead))				
		list.append(getConfigListEntry(_("bottom left"), config.plugins.MyMetrixStyle.InfobarBottomLeft))
		list.append(getConfigListEntry(_("bottom center"), config.plugins.MyMetrixStyle.InfobarBottomCenter))		
		list.append(getConfigListEntry(_("bottom right"), config.plugins.MyMetrixStyle.InfobarBottomRight))		
		list.append(getConfigListEntry(_("Show Record Icon"), config.plugins.MyMetrixStyle.InfobarRecordState))		
		list.append(getConfigListEntry(_("---------------------- SecondInfoBar ---------------------------------------------"), ))		
		list.append(getConfigListEntry(_("top left"), config.plugins.MyMetrixStyle.SecondInfobarTopLeft))
		list.append(getConfigListEntry(_("top center"), config.plugins.MyMetrixStyle.SecondInfobarTopCenter))		
		list.append(getConfigListEntry(_("top right"), config.plugins.MyMetrixStyle.SecondInfobarTopRight))						
		list.append(getConfigListEntry(_("Info Panel"), config.plugins.MyMetrixStyle.SecondInfobarEPGWidget))		

		ConfigListScreen.__init__(self, list)
		self["actions"] = ActionMap(["OkCancelActions","DirectionActions", "InputActions", "ColorActions"], {"left": self.keyLeft,"down": self.keyDown,"up": self.keyUp,"right": self.keyRight,"red": self.exit,"yellow": self.reboot, "blue": self.showInfo, "green": self.save,"cancel": self.exit}, -1)
		self.onLayoutFinish.append(self.UpdateComponents)

		
	def GetPicturePath(self):
		try:
			returnValue = self["config"].getCurrent()[1].value
			#print "\n selectedOption: " + returnValue + "\n"
			path = "/usr/lib/enigma2/python/Plugins/Extensions/MyMetrixStyle/images/" + returnValue + ".png"
			return path
		except:
			return "/usr/lib/enigma2/python/Plugins/Extensions/MyMetrixStyle/images/no-widget.png"
		
	def UpdatePicture(self):
		self.PicLoad.PictureData.get().append(self.DecodePicture)
		self.onLayoutFinish.append(self.ShowPicture)
	
	def ShowPicture(self):
		self.PicLoad.setPara([self["helperimage"].instance.size().width(),self["helperimage"].instance.size().height(),self.Scale[0],self.Scale[1],0,1,"#002C2C39"])
		self.PicLoad.startDecode(self.GetPicturePath())
		#print "showing image"
		
	def DecodePicture(self, PicInfo = ""):
		#print "decoding picture"
		ptr = self.PicLoad.getData()
		self["helperimage"].instance.setPixmap(ptr)	

	def UpdateComponents(self):
		self.UpdatePicture()

	def keyLeft(self):	
		ConfigListScreen.keyLeft(self)	
		self.ShowPicture()

	def keyRight(self):
		ConfigListScreen.keyRight(self)
		self.ShowPicture()
	
	def keyDown(self):
		#print "key down"
		self["config"].instance.moveSelection(self["config"].instance.moveDown)
		#ConfigListScreen.keyDown(self)
		self.ShowPicture()
		
	def keyUp(self):
		#print "key up"
		self["config"].instance.moveSelection(self["config"].instance.moveUp)
		#ConfigListScreen.keyUp(self)
		self.ShowPicture()
	
	def reboot(self):
		restartbox = self.session.openWithCallback(self.restartGUI,MessageBox,_("Do you really want to reboot now?"), MessageBox.TYPE_YESNO)
		restartbox.setTitle(_("Restart GUI"))
		
	def showInfo(self):
		self.session.open(MessageBox, _("Information"), MessageBox.TYPE_INFO)

	def save(self):
		for x in self["config"].list:
			if len(x) > 1:
        			x[1].save()
			else:
       				pass
       			
		###########READING DATA FILES
		try:
			self.appendSkinFile(self.daten + "header.xml")
				
			###InfoBar
			self.appendSkinFile(self.daten + "infobar-header.xml")
			#Style
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarStyle.value + ".xml")			
			#TopLeft
			# tomorrow			
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarTopLeft.value + ".xml")
			#TopCenter
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarTopCenter.value + ".xml")
			#TopRight
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarTopRight.value + ".xml")
			#InfobarHeadPanel
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarHead.value + ".xml")			
			#ChannelName
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarShowChannelname.value + ".xml")		
			#BottomLeft
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarBottomLeft.value + ".xml")
			#BottomCenter
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarBottomCenter.value + ".xml")			
			#BottomRight
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarBottomRight.value + ".xml")
			#RecordState
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.InfobarRecordState.value + ".xml")			
			#Footer
			self.appendSkinFile(self.daten + "screen-footer.xml")
			
			###SecondInfoBar
			self.appendSkinFile(self.daten + "secondinfobar-header.xml")
			#TopLeft
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.SecondInfobarTopLeft.value + ".xml")
			#TopCenter
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.SecondInfobarTopCenter.value + ".xml")
			#TopRight
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.SecondInfobarTopRight.value + ".xml")			
			#EPGWidget
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.SecondInfobarEPGWidget.value + ".xml")			
			#Footer
			self.appendSkinFile(self.daten + "screen-footer-sib.xml")
			
			#Channelselection
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.ChannelselectionStyle.value + ".xml")			
			#VOLUMESTYLE
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.VolumeStyle.value + ".xml")						
			#MENUSTYLE
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.MenuStyle.value +".xml")			
			#MovieSelectionStyle
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.MovieSelectionStyle.value +".xml")			
			#AMSSTYLE
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.AMSStyle.value +".xml")			
			#EMCSTYLE
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.EMCStyle.value +".xml")
			#MerlinEPGCenter
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.MerlinEPGCenterStyle.value +".xml")
			
			#SelectedLine
			self.appendSkinFile(self.daten + config.plugins.MyMetrixStyle.SkinSelectedLine.value +".xml")			
						
			###Main XML
			self.appendSkinFile(self.daten + "main.xml")

			xFile = open(self.dateiTMP, "w")
			for xx in self.skin_lines:
				xFile.writelines(xx)
			xFile.close()
			#Replaces <color name="metrixSelection" value="#00149bae" /> with SkinSelectedBackgroundColor.value
			o = open(self.datei,"w")
			for line in open(self.dateiTMP):
				
				line = line.replace("#00149bae", config.plugins.MyMetrixStyle.SkinSelectedBackgroundColor.value )
				line = line.replace("#00fffffd", config.plugins.MyMetrixStyle.SkinSelectedForegroundColor.value )
				line = line.replace("#40000000", config.plugins.MyMetrixStyle.SkinBackgroundColor.value )				
				line = line.replace("#00dddddd", config.plugins.MyMetrixStyle.SkinForegroundColor.value )
				line = line.replace("#00fffffc", config.plugins.MyMetrixStyle.SkinSelectedHelpTextColor.value )				
				line = line.replace("#00fffffe", config.plugins.MyMetrixStyle.SkinClockColor.value )
				line = line.replace("#00008A01", config.plugins.MyMetrixStyle.SkinCaidInfoColor.value )				
				line = line.replace("#00ddddde", config.plugins.MyMetrixStyle.SkinTunerInfoColor.value )				
				line = line.replace("#00999998", config.plugins.MyMetrixStyle.Channeldescription.value )			
				line = line.replace("p_bar", config.plugins.MyMetrixStyle.SkinProgressbarColor.value )				
				o.write(line)
			o.close()
			system('rm -rf ' + self.dateiTMP)

		except:
			self.session.open(MessageBox, _("Error creating Skin!"), MessageBox.TYPE_ERROR)
		configfile.save()
		restartbox = self.session.openWithCallback(self.restartGUI,MessageBox,_("GUI needs a restart to apply a new skin.\nDo you want to Restart the GUI now? \n\nDon't forgot to choose MetrixStyleHD.ME in skin selector!"), MessageBox.TYPE_YESNO)
		restartbox.setTitle(_("Restart GUI"))

	def restartGUI(self, answer):
		if answer is True:
			del self.PicLoad
			configfile.save()
			self.session.open(TryQuitMainloop, 3)
		else:
			self.close()
			
	def appendSkinFile(self,appendFileName):
		skFile = open(appendFileName, "r")
		file_lines = skFile.readlines()
		skFile.close()	
		for x in file_lines:
			self.skin_lines.append(x)
			

	def exit(self):
		for x in self["config"].list:
			if len(x) > 1:
					x[1].cancel()
			else:
       				pass
		del self.PicLoad
		self.close()
